<?
// ============================================================================
// PHPost 1.08
//
// Copyright 2002 by Mark Morley and WebGadgets.com
//
// PLEASE VIEW THE 'LICENSE' FILE
// ============================================================================


   // Global settings that are not normally edited.

   $config["version"] = "1.08";

   $config["languages"] = array(
      "Chinese",
      "Dansk",
      "Deutsch",
      "Dutch",
      "English",
      "Espa\xf1ol",
      "Fran\xe7ais",
      "\xcdslenska",
      "Italiano",
      "Japanese",
      "Korean",
      "Polski",
      "Portuguese",
      "Russian",
      "Slovensky",
      "Svenska",
      "Turkish",
   );

   set_magic_quotes_runtime( 0 );

   // Load the site-specific settings.

   include( "phpost.inc.php" );


   // Redirect to the secure URL if it's required.

   if( $config["ssl"] && !isset( $HTTPS ) )
   {
      header( "Location: " . $config["secure"] . "\r\n" );
      exit;
   }


   // Load in the default language file

   LoadLanguage( $config["lang"] );


   // If we are in paranoid mode we send a variety of headers that should
   // ensure that the page data is not cached anywhere (no guarantees though)

   if( $config["paranoid"] && $cmd != "view" )
   {
      header( "Expires: Mon, 26 Jul 1997 05:00:00 GMT" );
      header( "Last-Modified: " . gmdate( "D, d M Y H:i:s" ) . " GMT" );
      header( "Cache-Control: no-cache, must-revalidate" );
      header( "Pragma: no-cache" );
   }

   // If the command is "logout" do it, then display the login screen and
   // exit.

   if( $cmd == "logout" )
   {
      LogOut();
      LogIn();
   }

   // Build a key value based on a few items.  This is used to help ensure
   // that it's really the same person who originally logged in (ie: it is
   // used to provide a little protection against spoofed session IDs).  I
   // only use the first three octets of the user's IP address though because
   // if they are using a proxy cluster (like many @Home users) the last
   // octet will change.  We'll also use this as the encryption key for the
   // session data file.

   $x = substr( $REMOTE_ADDR, 0, strrpos( $REMOTE_ADDR, "." ) + 1 );
   $key1 = "$HTTPS $x $SERVER_ADDR $HTTP_USER_AGENT";

   // If a session data file does not already exist, or it is older than the
   // idle timeout, or we can't open it, the user is either trying to log in
   // or we need to display a login screen.

   $sid = trim( $sid );
   
   if( !file_exists( "phpost_cache/$sid.dat" ) ||
       (time() - filemtime( "phpost_cache/$sid.dat" ) > $config["idle"] ) ||
       ($fp = fopen( "phpost_cache/$sid.dat", "r" )) == 0 )
   {

      $prefs["username"] = trim( $username );
      $prefs["password"] = trim( $password );
      $prefs["pop"] = trim( $popserver );

      if( $config["pickpop"] == false || $prefs["pop"] == "" )
         $prefs["pop"] = $config["pop"];

      // If we get a null username or password then we display the login screen.

      $x = "phpost_temp/" . $cookie . ".cookie";
      if( file_exists( $x ) )
         unlink( $x );
      else
         LogIn();

      if( $prefs["username"] == "" || $prefs["password"] == "" )
         LogIn();

      // Otherwise we attempt to start a new session.

      else
      {
         // Generate a unique key value

         $key2 = uniqid( "", true );

         // The session ID is an md hash of key1 and key2

         $sid = md5( $key1 . $key2 );

         // Write key1, the username, and the password to the session file,
         // calling Encode() to encrypt the data.

         if( $fp = fopen( "phpost_cache/$sid.dat", "w" ) )
         {
            fputs( $fp, Encode( "$key1\n" . $prefs["username"] . "\n" . $prefs["password"] . "\n". $prefs["pop"] . "\n", $key1 ) );
            fclose( $fp );

            // Change permissions to "rw-r----" (UNIX systems)

            chmod( "phpost_cache/$sid.dat", 0640 );
         }
      }
   }

   // There is a session file, let's read it in.

   else
   {
      // Read in the session data file and close it

      $x = fgets( $fp, 500 );
      fclose( $fp );

      // Decode the data.

      $x = Decode( $x, $key1 );

      // Break it into bits separated by newlines.

      $x = explode( "\n", $x );
      $key = $x[0];
      $prefs["username"] = $x[1];
      $prefs["password"] = $x[2];
      $prefs["pop"] = $x[3];

      // If key1 does not match the stored key value, then this isn't the
      // same person, so we log them out (some basic protection against
      // spoofed session ID's.

      if( $key != $key1 )
      {
         LogOut();
         LogIn();
      }

      // Otherwise we're ok, so touch the session file to keep it fresh.

      else
         touch( "phpost_cache/$sid.dat" );
   }

   // If we can't establish a connection to the POP server with the supplied
   // username and password, display an error and delete the session file,
   // which effectively logs the user out.

   if( !Initialize() )
   {
      $notice = sprintf( $vocab["error"], $errstr );
      LogIn();

      if( file_exists( "phpost_cache/$sid.dat" ) )
         unlink( "phpost_cache/$sid.dat" );
   }

   // The POP server accepted us, so carry on.

   else
   {
      // If we are in paranoid mode (recommended) we change the session ID
      // on every successful connection to make it impossible to guess
      // (extra security).

      $oldsid = $sid;
      if( $config["paranoid"] && $cmd != "view" )
      {
         $key2 = uniqid( "", true );
         $sid = md5( $key1 . $key2 );
         @rename( "phpost_cache/$oldsid.dat", "phpost_cache/$sid.dat" );
         @rename( "phpost_cache/$oldsid.idx", "phpost_cache/$sid.idx" );
      }

      // Load in the user's preferences.

      LoadConfig();
      if( isset( $newlang ) )
         LoadLanguage( TranslateForeignChars( $newlang ) );

      // Display the header.

      if( $cmd != "view" )
         PrintHeader();

      // If the user changes the index sorting, or toggles the header display,
      // we update the user's preferences file so that these choices are
      // remembered between sessions.

      if( isset( $s ) || isset( $h ) )
      {
         if( isset( $s ) )
            $prefs["sort"] = $s;
         if( isset( $h ) )
            $prefs["hdrs"] = $h;
         $newhtml = $prefs["html"];
         $newimages = $prefs["images"];
         SaveConfig();
      }

      // Now we check for each of the possible commands and call a
      // corresponding function.

      if( $cmd == "read" )
      {
         include( "phpost_index.php" );
         include( "phpost_read.php" );
         ReadMessage( $msg );
      }
      else if( $cmd == "view" )
      {
         include( "phpost_index.php" );
         include( "phpost_view.php" );
         ViewPart( $msg, $part );
      }
      else if( $cmd == "delete" )
      {
         DeleteMessages();
         if( isset( $next ) && $msgcount > 0 )
         {
            include( "phpost_read.php" );
            ReadMessage( $next );
         }
         else
         {
            include( "phpost_list.php" );
            ShowIndex();
         }
      }
      else if( $cmd == "adb" )
      {
         LoadAddressBook();
         EditAddressBook();
      }
      else if( $cmd == $vocab["aupdate"] )
         UpdateEntry();
      else if( $cmd == $vocab["adelete"] )
         DeleteEntry();
      else if( $cmd == "config" )
         EditConfig();
      else if( $cmd == "save" )
      {
         SaveConfig();
         LoadConfig();
         $notice = $vocab["configsaved"];
         include( "phpost_index.php" );
         include( "phpost_list.php" );
         GetIndex();
         ShowIndex();
      }
      else if( $cmd == "compose" || $cmd == "reply" || $cmd == "forward" )
      {
         include( "phpost_compose.php" );
         ComposeMessage();
      }
      else if( $cmd == "send" )
      {
         include( "phpost_send.php" );
         if( SendMessage() )
            $notice = $vocab["messagesent"];
         else
            $notice = sprintf( $vocab["error"], $errstr );
         include( "phpost_index.php" );
         include( "phpost_list.php" );
         GetIndex();
         ShowIndex();
      }
      else
      {
         include( "phpost_index.php" );
         include( "phpost_list.php" );
         GetIndex();
         ShowIndex();
      }
   }


   // Close the connection to the POP server.

   Terminate();

   // Display the footer and we're all done!

   if( $cmd != "view" )
      PrintFooter();


// ----------------------------------------------------------------------------
// StartMenu()
//
// We call this when we are about to draw a new set of menu options.
// ----------------------------------------------------------------------------

   function StartMenu()
   {
      global $config;

      echo( "<table width=100% border=0 cellspacing=0 cellpadding=5>" );
      echo( "<tr class=menu><td>&nbsp;</td>" );
   }


// ----------------------------------------------------------------------------
// MenuOption()
//
// We call this function once for each menu option.  We pass it an optional URL
// and the text for the link.  If the URL is null we display the text in a
// "grayed out" color, otherwise it's clickable.
// ----------------------------------------------------------------------------

   function MenuOption( $url, $text )
   {
      global $config;

      if( $url == "" )
         echo( "<td nowrap>$text</td>" );
      else
         echo( "<td nowrap class=menuitem><a href=\"$url\">$text</a></td>" );
   }


// ----------------------------------------------------------------------------
// MenuSeparator()
//
// This function simply displays a "separator" between menu options.
// ----------------------------------------------------------------------------

   function MenuSeparator()
   {
      echo( "<td>|</td>" );
   }


// ----------------------------------------------------------------------------
// EndMenu()
//
// We call this function when we are done adding options to the menu bar.  This
// is also where we display any pending notice message (in red).
// ----------------------------------------------------------------------------

   function EndMenu()
   {
      global $config, $prefs, $notice, $HTTPS, $PHP_SELF;

      echo( "<td align=right>" );
      if( $config["secure"] == "" )
         echo( "&nbsp;" );
      else if( isset( $HTTPS ) )
         echo( "<a href=\"" . $config["insecure"] . "\"><img src=secure.gif width=16 height=17 border=0 alt=&nbsp;></a>" );
      else
         echo( "<a href=\"" . $config["secure"] . "\"><img src=insecure.gif border=0 height=16 width=17 alt=&nbsp;></a>" );
      echo( "</td></tr></table>" );

      echo( "<table width=100%><tr><td colspan=10><span class=notice>&nbsp;&nbsp;" );
      if( $notice != "" )
         echo( "$notice" );
      $notice = "";
      echo( "</span></td><td colspan=1 align=right><span class=address>" );
      if( $prefs["username"] != "" )
         echo( $prefs["username"] . " / " . $prefs["pop"] );
      echo( "&nbsp;&nbsp;</span></td></table>" );

      echo( "<table border=0 width=100% cellspacing=0 cellpadding=10>" );
      echo( "<tr><td>" );
   }


// ----------------------------------------------------------------------------
// LogIn()
//
// This function displays the login screen.
// ----------------------------------------------------------------------------

   function LogIn()
   {
      global $vocab, $config, $PHP_SELF, $notice;

      // Display the header.

      PrintHeader();

      // The menu bar for this screen is empty.

      StartMenu();
      EndMenu();

      // Draw the form that prompts for a username and password.

      echo( "<form method=post action=$PHP_SELF>" );
      echo( "<input type=hidden name=sid value=$sid>" );

      // Set a cookie.  Only accept logins where there is a matching
      // cookie file (prevents reloads that let you in using a cached
      // username/password).

      $x = uniqid( "", true );
      echo( "<input type=hidden name=cookie value=\"$x\">" );
      touch( "phpost_temp/" . $x . ".cookie" );

      echo( "<table border=0 cellspacing=0 cellpadding=2>" );

      echo( "<tr><td align=right class=login>" );
      echo( $vocab["username"] );
      echo( ":</td>" );
      echo( "<td><input name=username size=20></td></tr>" );

      echo( "<tr><td align=right class=login>" );
      echo( $vocab["password"] );
      echo( ":</td>" );
      echo( "<td><input name=password type=password size=20></td></tr>" );

      if( $config["pickpop"] )
      {
         echo( "<tr><td align=right class=login>" );
         echo( $vocab["popserver"] );
         echo( ":</td><td>" );
         $x = split( ",", $config["pop"] );
         if( sizeof( $x ) <= 1 )
         {
            echo( "<input name=popserver size=20 value=\"" );
            echo( $config["pop"] );
            echo( "\">" );
         }
         else
         {
            echo( "<select name=popserver>" );
            for( $i = 0; $i < sizeof( $x ); $i++ )
               echo( "<option value=\"" . $x[$i] . "\">" . $x[$i] . "\n" );
            echo( "</select>" );
         }
         echo( "</td></tr>" );
      }

      echo( "<tr><td></td><td><input type=submit value=\"" );
      echo( $vocab["login"] );
      echo( "\"></td></tr>" );

      echo( "</table>" );
      echo( "</form>" );

      // Display the footer.
      PrintFooter();
      exit;
   }


// ----------------------------------------------------------------------------
// LogOut()
//
// We call this function when we want to terminate a session.
// ----------------------------------------------------------------------------

   function LogOut()
   {
      global $sid;

      // If there is a session data file delete it.

      if( file_exists( "phpost_cache/$sid.dat" ) )
         unlink( "phpost_cache/$sid.dat" );

      // If there is an index cache file delete it.

      if( file_exists( "phpost_cache/$sid.idx" ) )
         unlink( "phpost_cache/$sid.idx" );
   }


// ----------------------------------------------------------------------------
// EditConfig()
//
// This function displays the screen where the user can edit their preferences.
// ----------------------------------------------------------------------------

   function EditConfig()
   {
      global $vocab, $prefs, $config, $PHP_SELF, $sid;

      // Display the menu bar.

      StartMenu();

      MenuOption( "$PHP_SELF?sid=$sid", $vocab["list"] );
      MenuSeparator();

      MenuOption( "$PHP_SELF?sid=$sid&cmd=compose", $vocab["compose"] );
      MenuSeparator();

      MenuOption( "$PHP_SELF?sid=$sid&cmd=adb", $vocab["abook"] );
      echo( "<td width=99%>&nbsp;</td>" );

      MenuOption( "$PHP_SELF?sid=$sid&cmd=logout", $vocab["logout"] );

      EndMenu();

      // Draw the form.

      echo( "<form method=post action=$PHP_SELF>" );
      echo( "<input type=hidden name=sid value=$sid>" );
      echo( "<input type=hidden name=cmd value=save>" );
      echo( "<table border=0 cellspacing=0 cellpadding=2>" );

      echo( "<tr><td class=header align=right valign=top>" );
      echo( $vocab["fullname"] );
      echo( ":</td><td>" );
      echo( "<input name=newname size=40 value=\"" );
      echo( $prefs["name"] );
      echo( "\"></td></tr>" );

      echo( "<tr><td class=header align=right valign=top>" );
      echo( $vocab["replyaddress"] );
      echo( ":</td><td>" );
      echo( "<input name=newemail size=40 value=\"" );
      echo( $prefs["email"] );
      echo( "\"></td></tr>" );

      echo( "<tr><td class=header align=right valign=top>" );
      echo( $vocab["signature"] );
      echo( ":</td><td>" );
      echo( "<textarea name=signature rows=4 cols=60>" );
      $x = "phpost_prefs/" . strtr( $prefs["username"] . "@" . $prefs["pop"], "/", "_" ) . ".sig";
      if( file_exists( $x ) )
         include( $x );
      echo( "</textarea></td></tr>" );

      echo( "<tr><td class=header align=right valign=top>" );
      echo( $vocab["language"] );
      echo( ":</td><td>" );
      echo( "<select name=newlang>" );
      for( $i = 0; $i < sizeof( $config["languages"] ); $i++ )
      {
         echo( "<option" );
         if( strnatcmp( $prefs["lang"], $config["languages"][$i] ) == 0 )
            echo( " selected" );
         echo( " value=\"" );
         echo( $config["languages"][$i] );
         echo( "\">" );
         echo( $config["languages"][$i] );
         echo( "\n" );
      }
      echo( "</select></td></tr>" );

      echo( "<tr><td class=header align=right valign=top>" );
      echo( $vocab["maxattachments"] );
      echo( ":</td><td>" );
      echo( "<input name=newattach size=3 value=\"" );
      echo( $prefs["attach"] );
      echo( "\"></td></tr>" );

      echo( "<tr><td class=header align=right valign=top>" );
      echo( $vocab["pagelength"] );
      echo( ":</td><td>" );
      echo( "<input name=newlength size=3 value=\"" );
      echo( $prefs["length"] );
      echo( "\"></td></tr>" );

      echo( "<tr><td class=header align=right valign=top>" );
      echo( $vocab["renderhtml"] );
      echo( ":</td><td>" );
      echo( "<input name=newhtml type=checkbox" );
      if( $prefs["html"] == "on" )
         echo( " checked" );
      echo( "></td></tr>" );

      echo( "<tr><td class=header align=right valign=top>" );
      echo( $vocab["renderimages"] );
      echo( ":</td><td>" );
      echo( "<input name=newimages type=checkbox" );
      if( $prefs["images"] == "on" )
         echo( " checked" );
      echo( "></td></tr>" );

      echo( "<tr><td></td><td>" );
      echo( "<input type=submit value=\"" );
      echo( $vocab["saveconfig"] );
      echo( "\"></td></tr>" );

      echo( "</table>" );
      echo( "</form>" );
   }


// ----------------------------------------------------------------------------
// LoadConfig()
//
// This function loads the user's preferences from a file.
// ----------------------------------------------------------------------------

   function LoadConfig()
   {
      global $vocab, $prefs, $config;

      // First we set up the default values for everything.

      $prefs["name"] = "";
      $prefs["email"] = $prefs["username"] . "@" . $config["domain"];
      $prefs["sort"] = "nd";
      $prefs["hdrs"] = "off";
      $prefs["attach"] = $config["attach"];
      $prefs["length"] = $config["length"];
      $prefs["lang"] = $config["lang"];
      $prefs["html"] = "on";
      $prefs["images"] = "off";

      // If a config file exists for this user and we can open it, read in
      // the data.

      $x = "phpost_prefs/" . strtr( $prefs["username"] . "@" . $prefs["pop"], "/", "_" ) . ".cfg";
      if( file_exists( $x ) && $fp = fopen( $x, "r" ) )
      {
         $prefs["name"] = chop( fgets( $fp, 100 ) );
         $prefs["email"] = chop( fgets( $fp, 100 ) );
         $prefs["sort"] = chop( fgets( $fp, 100 ) );
         $prefs["hdrs"] = chop( fgets( $fp, 100 ) );
         $prefs["attach"] = intval( chop( fgets( $fp, 100 ) ) );
         $prefs["length"] = intval( chop( fgets( $fp, 100 ) ) );
         $prefs["lang"] = chop( fgets( $fp, 100 ) );
         $prefs["html"] = chop( fgets( $fp, 100 ) );
         $prefs["images"] = chop( fgets( $fp, 100 ) );
         LoadLanguage( $prefs["lang"] );

         fclose( $fp );
         if( $prefs["email"] == "" )
            $prefs["email"] = $prefs["username"] . "@" . $config["domain"];
      }
   }


// ----------------------------------------------------------------------------
// SaveConfig()
//
// This fucntion saves the user's preferences and/or signature to a file.
// ----------------------------------------------------------------------------

   function SaveConfig()
   {
      global $prefs, $newname, $newemail, $newsort, $newhdrs, $newattach, $newlength, $newlang, $signature, $newhtml, $newimages;

      // If we can open the file for writing, save the data.

      $x = "phpost_prefs/" . strtr( $prefs["username"] . "@" . $prefs["pop"], "/", "_" ) . ".cfg";
      if( $fp = fopen( $x, "w" ) )
      {
         if( isset( $newname ) )
            $prefs["name"] = $newname;

         if( isset( $newemail ) )
            $prefs["email"] = $newemail;

         if( isset( $newsort ) )
            $prefs["sort"] = $newsort;

         if( isset( $newhdrs ) )
            $prefs["hdrs"] = $newhdrs;

         if( isset( $newattach ) )
            $prefs["attach"] = $newattach;

         if( isset( $newlength ) )
            $prefs["length"] = $newlength;

         if( isset( $newlang ) )
            $prefs["lang"] = $newlang;

         $prefs["html"] = $newhtml;
         $prefs["images"] = $newimages;

         // Write the values to the file.

         fputs( $fp, $prefs["name"] . "\n" );
         fputs( $fp, $prefs["email"] . "\n" );
         fputs( $fp, $prefs["sort"] . "\n" );
         fputs( $fp, $prefs["hdrs"] . "\n" );
         fputs( $fp, $prefs["attach"] . "\n" );
         fputs( $fp, $prefs["length"] . "\n" );
         fputs( $fp, $prefs["lang"] . "\n" );
         fputs( $fp, $prefs["html"] . "\n" );
         fputs( $fp, $prefs["images"] . "\n" );

         fclose( $fp );

         // Change permissions to "rw-r----" (UNIX systems)

         chmod( $x, 0640 );
      }

      // If $signature is set then we save its value to a different file.

      $x = "phpost_prefs/" . strtr( $prefs["username"] . "@" . $prefs["pop"], "/", "_" ) . ".sig";
      if( isset( $signature ) && strlen( $signature ) < 2048 && $fp = fopen( $x, "w" ) )
      {
         fputs( $fp, chop( $signature ) );
         fclose( $fp );

         // Change permissions to "rw-r----" (UNIX systems)

         chmod( $x, 0640 );
      }
   }


// ----------------------------------------------------------------------------
// DeleteMessages()
//
// This function deletes messages from the mailbox.
// ----------------------------------------------------------------------------

   function DeleteMessages()
   {
      global $vocab, $prefs, $HTTP_POST_VARS, $socket, $index, $PHP_SELF, $sid, $msgcount, $checklist, $notice, $msg;

      // Load the index array.  If GetIndex() returns TRUE then the mailbox
      // contents must have changed since the last access.  To avoid the
      // accidental deletion of the wrong messages we ignore the delete
      // request in this case.  You may want to change this.

      include( "phpost_index.php" );
      if( GetIndex() )
         $notice = $vocab["nodelete"];
      else
      {
         // Loop through all the form variables that begin with "cb" and
         // and delete the corresponding messages.

         $count = 0;
         while( list( $key, $value ) = each( $HTTP_POST_VARS ) ) 
            if( substr( $key, 0, 2 ) == "cb" )
            {
               // Extract the message number (cb1 = 1, cb2 = 2, etc)

               // $n = $index[intval( substr( $key, 2 ) )][number];
               $n = intval( substr( $key, 2 ) );

               // Issue the DELE command to delete the message and read the
               // response code.  As usual, if it starts with a '+' then we
               // were successful.

               fputs( $socket, "DELE $n\r\n" );
               $line = fgets( $socket, 500 );
               if( substr( $line, 0, 1 ) == "+" )
                  $count++;
            }

         // This same routine is also used to delete a single specific
         // message while reading it, so if $msg is set we delete it.

         if( $msg != "" )
         {
            // $n = $index[intval( $msg ) - 1][number];
            fputs( $socket, "DELE $msg\r\n" );
            $line = fgets( $socket, 500 );
            if( substr( $line, 0, 1 ) == "+" )
               $count++;
         }

         // If we deleted any messages we need to terminate the POP session
         // to finalize things and then reconnect and retrieve the index
         // again.

         if( $count > 0 )
         {
            Terminate();
            Initialize();
            GetIndex();
         }
      
         $notice = sprintf( $vocab["deletedmsgs"], $count );
      }
   }


// ----------------------------------------------------------------------------
// AddHrefs()
//
// This utility function takes a string, looks for any URLs or email addresses,
// and adds anchor tags to make them clickable.
// ----------------------------------------------------------------------------

   function AddHrefs( $s )
   {
      global $PHP_SELF, $sid;

      // This regular expression matches URLs of the form xxx://xxx.xxx
      // The link it creates opens the URL in a separate window (note the
      // "target=_blank" part.

      $s = ereg_replace("([[:alpha:]]+)://([^[:space:]]*)([[:alnum:]#?/&=])",
           "<a href=\"\\1://\\2\\3\" target=\"_blank\">\\0</a>", $s ); 

      // This one matches email addresses of the form xxx@xxx.xxx
      // The link it creates calls PHPost to send the mail.

      $s = ereg_replace( "([[:alnum:]\._=-]+)@([[:alnum:]\._-]+)\.([[:alpha:]]+)",
           "<a href=$PHP_SELF?sid=$sid&cmd=compose&to=\\0>\\0</a>", $s );

      return $s;
   }


// ----------------------------------------------------------------------------
// Encode()
//
// Since we can't very well require the user to enter their username and
// password for each and every access, and since POP is stateless, we need
// some way to store the user's username and password between hits.  We do
// this by storing the data in a session file.  This utility function is
// used to encrypt the data so that even if someone were to gain access to
// the session file, the data would be unreadable.
//
// We try to use the mcrypt library if it's available (highly recommended!).
// If it's not it falls back to simple base 64 encoding, which isn't really
// secure at all but it's *slightly* better than storing the data as plain
// text.
//
// The choice of a key is important.  When we call this function we'll be
// sending in the value we came up with for $key1, which consists of part of
// the IP address, the server name, the browser name, etc.  This means that
// you'd have to know all of those things in order to decrypt the file, which
// is highly unlikely (although not impossible!).
// ----------------------------------------------------------------------------

   function Encode( $data, $key ) 
   { 
      global $config;

      if( function_exists( "mcrypt_module_open" ) )
      {
         $td = mcrypt_module_open( MCRYPT_TripleDES, "", MCRYPT_MODE_ECB, "" ); 
         $iv = mcrypt_create_iv( mcrypt_enc_get_iv_size( $td ), MCRYPT_RAND ); 
         $data = @mcrypt_ecb( MCRYPT_TripleDES, md5( $key ), $data, MCRYPT_ENCRYPT, $iv );
         mcrypt_module_close( $td );
      }
      $data = base64_encode( $data );
      return $data; 
   } 


// ----------------------------------------------------------------------------
// Decode()
//
// The companion function to Encode()
// ----------------------------------------------------------------------------

   function Decode( $data, $key ) 
   { 
      global $config;

      $data = base64_decode( $data );
      if( function_exists( "mcrypt_module_open" ) )
      {
         $td = mcrypt_module_open( MCRYPT_TripleDES, "", MCRYPT_MODE_ECB, "" ); 
         $iv = mcrypt_create_iv( mcrypt_enc_get_iv_size( $td ), MCRYPT_RAND ); 
         $data = @mcrypt_ecb( MCRYPT_TripleDES, md5( $key ), $data, MCRYPT_DECRYPT, $iv ); 
         mcrypt_module_close( $td );
      }
      return $data; 
   } 


// ----------------------------------------------------------------------------
// Initialize()
//
// This function is called to establish a connection and log into the POP
// server.  If it is successful it returns TRUE, otherwise it sets $ERRSTR
// and returns FALSE.
// ----------------------------------------------------------------------------

   function Initialize()
   {
      global $config, $prefs, $socket, $errstr;

      // Extract the POP server and optional port number (110 is default)
      if( ($i = strpos( $prefs["pop"], ":" )) > 0 )
      {
         $h = substr( $prefs["pop"], 0, $i );
         $p = intval( substr( $prefs["pop"], $i + 1 ) );
      }
      else
      {
         $h = $prefs["pop"];
         $p = 110;
      }

      // If "popdomain" is set, then the username we send will include the
      // domain, otherwise we just use the username as is.

      $u = $prefs["username"];
      if( $config["popdomain"] == 1 )
         $u .= "@" . $config["domain"];

      // Open the connection
      $socket = fsockopen( $h, $p, $errno, $errstr, 15 );
      if( ! $socket )
      {
         $errstr = "Connection refused (" . $prefs["pop"] . ")";
         return false;
      }

      // Get POP banner.  It it begins with a '+' things are ok, otherwise
      // it's an error.
      $line = fgets( $socket, 500 );
      if( substr( $line, 0, 1 ) != "+" )
      {
         $errstr = substr( $line, 5 );
         return false;
      }

      $ok = 0;

      // Is APOP enabled and is there a message ID in the banner?
      if( $config["apop"] == 1 && ereg( "<(.+@.+)>", $line, $r ) )
      {
         // Yes, so let's try an APOP login

         $digest = md5( $r[1] . $prefs["password"] );
         fputs( $socket, "APOP " . $u . " " . $digest . "\r\n" );

         //
         $line = fgets( $socket, 500 );
         if( substr( $line, 0, 1 ) == "+" )
            $ok = 1;
      }

      // If $ok is still 0, then we try a regular login (it will only be
      // 1 if there was a message ID in the banner and APOP was successful
      if( $ok == 0 )
      {
         fputs( $socket, "USER " . $u . "\r\n" );
         $line = fgets( $socket, 500 );
         if( substr( $line, 0, 1 ) != "+" )
         {
            $errstr = substr( $line, 5 );
            return false;
         }

         // Send the password
         fputs( $socket, "PASS " . $prefs["password"] . "\r\n" );

         $line = fgets( $socket, 500 );
         if( substr( $line, 0, 1 ) != "+" )
         {
            $errstr = substr( $line, 5 );
            return false;
         }
      }

      // Login was successful
      return true;
   }


// ----------------------------------------------------------------------------
// Terminate()
//
// This function is called to quit the POP session and close the socket.
// ----------------------------------------------------------------------------

   function Terminate()
   {
      global $socket;

      if( $socket )
      {
         fputs( $socket, "QUIT\r\n" );
         fgets( $socket, 500 );
         fclose( $socket );
      }
   }


// ----------------------------------------------------------------------------
// PrintHeader()
//
// This function displays a header.  You will likely want to customize this.
// ----------------------------------------------------------------------------

   function PrintHeader()
   {
      global $config, $prefs, $vocab;

      //header( "Content-Type: text/html; charset=\"" . $vocab["charset"] . "\"" );

      echo( "<title>" . $config["title"] . "</title>" );

      echo( "<meta http-equiv=\"Content-Type\" content=\"text/html; charset=" . $vocab["charset"] . "\">\n" );

      // If we're in paranoid mode we try to disable caching in every way
      // possible...  this is one of those ways.

      if( $config["paranoid"] )
         echo( "<meta http-equiv=\"Expires\" content=\"0\">" );

      $x = "phpost_" . TranslateForeignChars( $prefs["lang"] ) . ".css";
      if( !file_exists( $x ) )
         $x = "phpost.css";
      echo( "<link rel=stylesheet href=\"$x\" TYPE=\"text/css\">\n" );

      echo( "<table width=100% border=0 cellspacing=0 cellpadding=2>" );
      echo( "<tr class=titlebar><td height=45>" );
      echo( $config["title"] );
      echo( "</td></tr>" );
      echo( "</table>" );
   }


// ----------------------------------------------------------------------------
// PrintFooter()
//
// This function is the counterpart to PrintHeader().  It displays the footer
// information.  You will likely want to customize this.  make sure it closes
// any tags that you opened in the header.
// ----------------------------------------------------------------------------

   function PrintFooter()
   {
      echo( "<hr><span class=plain>&copy; 2002 <a href=http://webgadgets.com/>WebGadgets.com</a>" );
      echo( "</span></td></tr></table>" );

      // Flush the output so the user can see stuff while we purge the cache
      // directory of stale files.  This has the effect of logging out any
      // idle users.

      flush();
      PurgeCache();
   }


// ----------------------------------------------------------------------------
// PurgeCache()
//
// This function purges any stale index or session data files that are older
// then tha idle timeout.
// ----------------------------------------------------------------------------

   function PurgeCache()
   {
      global $config;

      $t = time();

      // Open the cache directory

      if( $dir = opendir( "phpost_cache" ) )
      {
         // Read in the name of each file in the cache directory

         while( $file = readdir( $dir ) )
         {
            // If the file ends with ".idx" or ".dat" and it's older than
            // the idle timeout, delete it.

            $ext = substr( $file, strrpos( $file, "." ) );
            if( ($ext == ".idx" || $ext == ".dat") && ($t - filemtime( "phpost_cache/$file" )) > $config["idle"] )
               unlink( "phpost_cache/$file" );
         }

         // Close the cache directory

         closedir( $dir );
      }

      // Now do sthe same thing for the temp directory

      if( $dir = opendir( "phpost_temp" ) )
      {
         while( $file = readdir( $dir ) )
         {
            if( $file[0] != "." && ($t - filemtime( "phpost_temp/$file" )) > $config["purgetmp"] )
               unlink( "phpost_temp/$file" );
         }

         // Close the cache directory

         closedir( $dir );
      }
   }


// ----------------------------------------------------------------------------
// UUEncode()
//
// Since PHP doesn't have a uuencode() function I had to roll my own.  This
// works just like base64_encode() except that it uuencodes the data.
// ----------------------------------------------------------------------------

   function UUEncode( $data )
   {
      $l = strlen( $data );
      $result = chr( $l + 32 );
      $n = $l % 3;
      $l = ceil( $l / 3 );
      $o = 0;
      for( $j = 0; $j < $l; $j++ )
      {
         $t[0] = ord( $data[$o++] );
         $t[1] = ord( $data[$o++] );
         $t[2] = ord( $data[$o++] );

         $q[0] = $t[0] >> 2;
         $q[1] = (($t[0] << 4) & 0x30) + (($t[1] >> 4) & 0x0F);
         $q[2] = (($t[1] << 2) & 0x3C) + (($t[2] >> 6) & 0x03);
         $q[3] = $t[2] & 0x3F;

         for( $i = 0; $i < 4; $i++ )
         {
            if( $q[$i] == 0 )
               $q[$i] = 96;
            else
               $q[$i] += 32;
         }

         $result .= chr( $q[0] ) . chr( $q[1] ) . chr( $q[2] ) . chr( $q[3] );
      }
      return $result;
   }

// ----------------------------------------------------------------------------
// UUDecode()
//
// Since PHP doesn't have a uudecode() function I had to roll my own.  This
// works just like base64_decode() except that it uudecodes the data.
// ----------------------------------------------------------------------------

   function UUDecode( $data, $method )
   {
      $result = "";
      $l = strlen( $data );
      if( $l % 2 == 1 )
      {
         $data = substr( $data, 1 );
         $l--;
      }
      $l >>= 2;
      $o = 0;
      for( $j = 0; $j < $l; $j++ )
      {
         $q[0] = ord( $data[$o++] ) - 32;
         $q[1] = ord( $data[$o++] ) - 32;
         $q[2] = ord( $data[$o++] ) - 32;
         $q[3] = ord( $data[$o++] ) - 32;

         $result .= chr( ($q[0] << 2) + (($q[1] & 0x30) >> 4) );
         $result .= chr( (($q[1] & 0x0F) << 4) + (($q[2] & 0x3C) >> 2) );
         $result .= chr( (($q[2] & 0x03) << 6) + ($q[3] & 0x3F) );
      }
      return $result;
   }


// ----------------------------------------------------------------------------
// TranslateForeignChars()
//
// This function replaces all accented characters with their non-accented
// visually equivalent counterparts.  Used to generate filenames containing
// plain ASCII codes.
// ----------------------------------------------------------------------------

   function TranslateForeignChars( $l )
   {
      $l = strtr( $l, "\xc0\xe0\xc1\xe1\xc2\xe2\xc3\xe3\xc4\xe4\xc5\xe5", "AaAaAaAaAaAa" );
      $l = strtr( $l, "\xc8\xe8\xc9\xe9\xca\xea\xcb\xeb", "EeEeEeEe" );
      $l = strtr( $l, "\xcc\xec\xcd\xed\xce\xee\xcf\xef", "IiIiIiIi" );
      $l = strtr( $l, "\xd2\xf2\xd3\xf3\xd4\xf4\xd5\xf5\xd6\xf6", "OoOoOoOoOo" );
      $l = strtr( $l, "\xd2\xf2\xd3\xf3\xd4\xf4\xd5\xf5\xd6\xf6", "OoOoOoOoOo" );
      $l = strtr( $l, "\xd9\xf9\xda\xfa\xdb\xfb\xdc\xfc", "UuUuUuUu" );
      $l = strtr( $l, "\xdf\xc7\xe7\xd1\xf1\xfd\xff", "BCcNnyy" );
      return $l;
   }


// ----------------------------------------------------------------------------
// LoadLanguage()
//
// This function loads in a language file and sets the locale, etc.
// ----------------------------------------------------------------------------

   function LoadLanguage( $l )
   {
      global $vocab;

      $l = strtr( $l, "/.", "__" );
      $l = TranslateForeignChars( $l );
      if( file_exists( "phpost_$l.inc" ) )
      {
         include( "phpost_$l.inc" );
         setlocale( LC_ALL, $vocab["locale"] );
      }
   }


   function FindBoundary( $b )
   {
      global $socket;

      $b2 = $b . "--";
      while( ($line = chop( fgets( $socket, 10000 ) )) != "." && $line != $b && $line != $b2 );
      return $line;
   }


   function ExtractTEXT( $b, $a )
   {
      global $socket;

      $b2 = $b . "--";
      while( ($line = chop( fgets( $socket, 10000 ) )) != "." && $line != $b && $line != $b2 )
      {
         if( strncmp( $line, "..", 2 ) == 0 )
            $line = substr( $line, 1 );
         if( $a )
         {
            echo( AddHrefs( htmlentities( $line ) ) );
            echo( "<br>\n" );
         }
         else
            echo( "$line\n" );
      }
      return $line;
   }


// ----------------------------------------------------------------------------
// ExtractQP()
//
// This function extracts a quoted-printable MIME part.
// ----------------------------------------------------------------------------

   function ExtractQP( $b, $a, $out )
   {
      global $socket;

      $b2 = $b . "--";
      while( ($line = chop( fgets( $socket, 10000 ) )) != "." && $line != $b && $line != $b2 )
      {
         if( strncmp( $line, "..", 2 ) == 0 )
            $line = substr( $line, 1 );
         if( $out )
            fputs( $out, quoted_printable_decode( $line ) );
         else
         {
            if( $a )
               $line = AddHrefs( htmlentities( $line ) );
            echo( quoted_printable_decode( $line ) );
            if( $a && substr( $line, -1 ) != "=" )
               echo( "<br>\n" );
         }
      }
      return $line;
   }

// ----------------------------------------------------------------------------
// ExtractBASE64()
//
// This function reads data from the socket, base64 decodes it, and outputs
// it to stdout or a file descriptor.  It returns the last line read.
// ----------------------------------------------------------------------------

   function ExtractBASE64( $b, $out )
   {
      global $socket;

      $b2 = $b . "--";
      if( $out )
      {
         while( ($line = chop( fgets( $socket, 10000 ) )) != "." && $line != $b && $line != $b2 )
            fputs( $out, base64_decode( $line ) );
      }
      else
      {
         while( ($line = chop( fgets( $socket, 10000 ) )) != "." && $line != $b && $line != $b2 )
            echo( base64_decode( $line ) );
      }
      return $line;
   }


// ----------------------------------------------------------------------------
// ExtractUU()
//
// This function reads data from the socket, uudecodes it, and outputs
// it to stdout or a file descriptor.  It returns the last line read.
// ----------------------------------------------------------------------------

   function ExtractUU( $b, $out )
   {
      global $socket;

      $b2 = $b . "--";
      while( ($line = chop( fgets( $socket, 10000 ) )) != "." && $line != $b && $line != $b && strcasecmp( substr( $line, 0, 5 ), "begin" ) != 0 );
      if( strcasecmp( substr( $line, 0, 5 ), "begin" ) == 0 )
      {
         if( $out )
            while( ($line = chop( fgets( $socket, 10000 ) )) != "." && $line != $b && $line != $b2 && strcasecmp( $line, "end" ) != 0 )
               fputs( $out, UUDecode( $line, "uu" ) );
         else while( ($line = chop( fgets( $socket, 10000 ) )) != "." && $line != $b && $line != $b2 && strcasecmp( $line, "end" ) != 0 )
               echo( UUDecode( $line, "uu" ) );
         while( ($line = chop( fgets( $socket, 10000 ) )) != "." && $line != $b && $line != $b2 );
      }
      return $line;
   }


// ----------------------------------------------------------------------------
// B64QPDecode()
//
// This function is used to decode BASE64 and/or QUOTED PRINTABLE substrings
// in certain headers.
// ----------------------------------------------------------------------------

   function B64QPDecode( $s )
   {
      // Start by assuming that the final result will be unchanged

      $result = $s;

      // Loop until we can't find "=?" in the result any more (we loop
      // because there may be multiple encoded substrings, not just one)

      while( $begin = strpos( $result, "=?" ) )
      {
         // Save a lowercase copy of the current result (PHP needs stripos!)

         $lr = strtolower( $result );

         // Extract the left part (everything prior to the encoded substring)

         $left = substr( $result, 0, $begin );

         // If it isn't QUOTED PRINTABLE (?q?) or BASE64 (?b?) then we bail
         // leaving things just the way they are.

         if( ($b = strpos( $lr, "?q?" )) == false && ($b = strpos( $lr, "?b?" )) == false )
            break;

         // Extract the middle part (the encoded substring)

         $rest = substr( $result, $b + 3 );
         $e = strpos( $rest, "?=" );
         $middle = substr( $rest, 0, $e );

         // Extract the right part (everything after the substring)

         $right = substr( $rest, $e + 2 );

         // Decode the substring and build a new result

         if( strpos( $lr, "?q?" ) )
            $result = $left . quoted_printable_decode( $middle ) . $right;
         else
            $result = $left . base64_decode( $middle ) . $right;

         // Replace underscores with spaces

         $result = str_replace( "_", " ", $result );
      }
      return $result;
   }

   function LoadAddressBook()
   {
      global $addressbook, $prefs;

      $file = "phpost_prefs/" . $prefs["username"] . "@" . $prefs["pop"] . ".adb";
      if( $in = @fopen( $file, "r" ) )
      {
         while( $line = chop( fgets( $in, 10000 ) ) )
         {
            $fields = split( "[\t]", $line );
            $key = $fields[0];
            $addressbook[$key] = $fields[1];
         }
         fclose( $in );
      }
   }

   function AddressLookup( $s )
   {
      global $addressbook;

      // escape/remove any commas that are enclosed in quotes
      $x = split( "[,]+", $s );

      $s2 = "";
      foreach( $x as $addr )
      {
         if( isset( $addressbook ) && strpos( $addr, "@" ) === false )
            foreach( $addressbook as $key => $value )
               if( !strcasecmp( $key, $addr ) )
               {
                  $addr = $addressbook[$key];
                  break;
               }
         if( $s2 == "" )
            $s2 = $addr;
         else
            $s2 .= "," . $addr;
      }
      return $s2;
   }

   function EditAddressBook()
   {
      global $PHP_SELF, $sid, $vocab, $addressbook;

      StartMenu();

      MenuOption( "$PHP_SELF?sid=$sid", $vocab["list"] );
      MenuSeparator();

      MenuOption( "$PHP_SELF?sid=$sid&cmd=config", $vocab["config"] );
      echo( "<td width=99%>&nbsp;</td>" );

      MenuOption( "$PHP_SELF?sid=$sid&cmd=logout", $vocab["logout"] );

      EndMenu();

      echo( "<form method=post action=$PHP_SELF>" );
      echo( "<input type=hidden name=sid value=$sid>" );

      echo( "<table border=0>" );
      echo( "<tr><td class=plain>" . $vocab[alias] . ":<br><input name=alias size=10></td>");
      echo( "<td class=plain>" . $vocab[alist] . ":<br><input name=value size=50></td>");
      echo( "<tr><td class=plain colspan=2>\n" );
      echo( "<select name=addr onchange=\"document.forms[0].alias.value=document.forms[0].addr.options[document.forms[0].addr.options.selectedIndex].text;document.forms[0].value.value=document.forms[0].addr.options[document.forms[0].addr.options.selectedIndex].value;return true\">\n" );
      echo( "<option value=\"\">\n" );
      if( isset( $addressbook ) ) foreach( $addressbook as $key => $value )
         if( $addressbook[$key] != "" )
         {
            echo( "<option value=\"" );
            echo( $addressbook[$key] );
            echo( "\">$key\n" );
         }
      echo( "</select>\n" );
      echo( "<input type=submit name=cmd value=\"" . $vocab["aupdate"] . "\"> " );
      echo( "<input type=submit name=cmd value=\"" . $vocab["adelete"] . "\"><p>" );
      echo( "</td></tr>\n" );
      echo( "</tr></table>" );
      echo( "</form>" );
   }

   function DeleteEntry()
   {
      global $addressbook, $alias, $notice;

      LoadAddressBook();
      $addressbook[$alias] = "";
      SaveAddressBook();
      $notice = $alias;
      EditAddressBook();
   }

   function UpdateEntry()
   {
      global $addressbook, $alias, $value, $notice;

      LoadAddressBook();
      $addressbook[$alias] = $value;
      SaveAddressBook();
      $notice = "$alias => " . $value;
      EditAddressBook();
   }

   function SaveAddressBook()
   {
      global $addressbook, $prefs;

      $file = "phpost_prefs/" . $prefs["username"] . "@" . $prefs["pop"] . ".adb";
      if( $out = @fopen( $file, "w" ) )
      {
         foreach( $addressbook as $key => $value )
            if( $addressbook[$key] != "" )
               fputs( $out, $key . "\t" . $addressbook[$key] . "\n" );
         fclose( $out );
      }
   }
?>
