<?
// ----------------------------------------------------------------------------
// ReadMessage()
//
// This function displays a complete message for reading.
// ----------------------------------------------------------------------------

   function ReadMessage( $num )
   {
      global $vocab, $prefs, $config, $socket, $PHP_SELF, $sid, $h, $msgcount, $index;

      GetIndex();
      if( $num > $msgcount )
         $num = $msgcount;
      else if( $num < 1 )
         $num = 1;

      StartMenu();
      if( $prefs["length"] > 0 )
         $x = floor( ($num - 1) / $prefs["length"] ) * $prefs["length"];
      else
         $x = 0;
      if( $x > 0 )
         MenuOption( "$PHP_SELF?sid=$sid&first=$x", $vocab["list"] );
      else
         MenuOption( "$PHP_SELF?sid=$sid", $vocab["list"] );
      MenuSeparator();
      MenuOption( "$PHP_SELF?sid=$sid&cmd=compose", $vocab["compose"] );
      MenuSeparator();
      $realnum = $index[$num - 1][number];
      MenuOption( "$PHP_SELF?sid=$sid&cmd=reply&msg=$realnum", $vocab["reply"] );
      MenuSeparator();
      MenuOption( "$PHP_SELF?sid=$sid&cmd=forward&msg=$realnum", $vocab["forward"] );
      MenuSeparator();
      if( $num == 1 )
         MenuOption( "", $vocab["previous"] );
      else
      {
         $x = $num - 1;
         MenuOption( "$PHP_SELF?sid=$sid&cmd=read&msg=$x", $vocab["previous"] );
      }
      MenuSeparator();
      if( $num == $msgcount )
         MenuOption( "", $vocab["next"] );
      else
      {
         $x = $num + 1;
         MenuOption( "$PHP_SELF?sid=$sid&cmd=read&msg=$x", $vocab["next"] );
      }
      MenuSeparator();
      MenuOption( "$PHP_SELF?sid=$sid&cmd=delete&msg=$realnum&next=$num", $vocab["delete"] );
      MenuSeparator();
      MenuOption( "$PHP_SELF?sid=$sid&cmd=config", $vocab["config"] );
      echo( "<td width=99%>&nbsp;</td>" );
      MenuOption( "$PHP_SELF?sid=$sid&cmd=logout", $vocab["logout"] );
      EndMenu();

      // Request the message from the POP server

      $x = $index[$num - 1][number];
      fputs( $socket, "RETR $x\r\n" );
      $line = fgets( $socket, 500 );
      if( substr( $line, 0, 1 ) == "+" )
      {
         // Set up some default values

         $from = "Anonymous";
         $date = "Unknown";
         $subject = "No subject";
         $to = "Unknown recipients";

         // Read the headers.  Save them all in one string for later, but also
         // extract certain individual headers as well.

         $headerlist = "";
         while( ($line = chop( fgets( $socket, 1000 ) )) != "." && $line != "" )
         {
            if( function_exists( "wordwrap" ) )
               $line = wordwrap( $line, 80, "\n\t" );
            $headerlist .= $line . "\n";
            if( strcasecmp( substr( $line, 0, 5 ), "FROM:" ) == 0 )
               $from = B64QPDecode( substr( $line, 5 ) );
            else if( strcasecmp( substr( $line, 0, 5 ), "DATE:" ) == 0 )
               $date = substr( $line, 5 );
            else if( strcasecmp( substr( $line, 0, 8 ), "SUBJECT:" ) == 0 )
               $subject = B64QPDecode( substr( $line, 8 ) );
            else if( strcasecmp( substr( $line, 0, 3 ), "TO:" ) == 0 )
               $to = B64QPDecode( substr( $line, 3 ) );
         }

         $from = str_replace( "<", "&lt;", $from );
         $to = str_replace( "<", "&lt;", $to );
         $subject = str_replace( "<", "&lt;", $subject );

         // We display certain key headers always (Date, From, To, Subject)

         echo( "<table width=100% border=0 cellspacing=0 cellpadding=5><tr><td>" );
         echo( "<table border=0 cellspacing=0 cellpadding=3>" );

         echo( "<tr><td class=header nowrap align=right valign=top>" );
         echo( $vocab["message"] );
         echo( ":</td>" );
         echo( "<td class=plain width=99%>$num / $msgcount</td></tr>" );

         echo( "<tr><td class=header nowrap align=right valign=top>" );
         echo( $vocab["date"] );
         echo( ":</td>" );
         echo( "<td class=plain>$date</td></tr>" );

         echo( "<tr><td class=header nowrap align=right valign=top>" );
         echo( $vocab["from"] );
         echo( ":</td>" );
         printf( "<td class=plain>%s</td></tr>", addhrefs( $from ) );

         echo( "<tr><td class=header nowrap align=right valign=top>" );
         echo( $vocab["to"] );
         echo( ":</td>" );
         printf( "<td class=plain>%s</td></tr>", addhrefs( $to ) );

         echo( "<tr><td class=header nowrap align=right valign=top>" );
         echo( $vocab["subject"] );
         echo( ":</td>" );
         printf( "<td class=plain>%s</td></tr>", addhrefs( $subject ) );
         echo( "</table>" );
         echo( "</td></tr>" );

         echo( "<tr><td>" );


         // If the user wants to see all the headers, display them

         if( strcasecmp( $prefs["hdrs"], "on" ) == 0 )
         {
            echo( "<a href=$PHP_SELF?sid=$sid&cmd=read&msg=$num&h=off><span class=hdrtoggle>" );
            echo( $vocab["hideheaders"] );
            echo( "</span></a><p>" );
            $headerlist = AddHrefs( str_replace( "<", "&lt;", B64QPDecode( $headerlist ) ) );
            echo( "<pre><span class=headerlist>$headerlist</span></pre>" );
         }
         else
         {
            echo( "<a href=$PHP_SELF?sid=$sid&cmd=read&msg=$num&h=on><span class=hdrtoggle>" );
            echo( $vocab["showheaders"] );
            echo( "</span></a><p>" );
         }

         $n = 0;
         if( eregi( "boundary *= *[\"]*([^\r\n\"]+)", $headerlist, $reg ) )
         //if( eregi( "boundary *= *[\"]*([^\r\n \"]+)", $headerlist, $reg ) )
         {
            $boundary[0] = "--" . $reg[1];
            FindBoundary( $boundary[0] );
            $headerlist = "";
         }
         else
            $boundary[0] = "=_";
         $b2 = $boundary[0] . "--";

            while( sizeof( $boundary ) > 0 && $line != "." && $line != $b2 )
            {
               // Read the MIME headers for this part

               if( $headerlist == "" )
               {
                  $parthdr = "";
                  while( ($line = chop( fgets( $socket, 10000 ) )) != "." && $line != "" )
                     $parthdr .= $line . "\n";
               }
               else
               {
                  $parthdr = $headerlist;
                  $headerlist = "";
               }

               // Extract the content type for this part

               if( eregi( "content-type: *([^; \n]+)", $parthdr, $reg ) )
                  $parttype = $reg[1];
               else
                  $parttype = "text/plain";

               if( stristr( $parttype, "multipart" ) && eregi( "boundary *= *[\"]*([^\r\n \"]+)", $parthdr, $reg ) )
               {
                  array_unshift( $boundary, "--" . $reg[1] );
                  $b2 = $boundary[0] . "--";
                  FindBoundary( $boundary[0] );
                  continue;
               }
               else
                  $n++;


               // Extract the filename for this part

               if( eregi( "name *= *[\"]([^\"]+)[\"]", $parthdr, $reg ) )
                  $partname = $reg[1];
               else
                  $partname = sprintf( "PART_%03d", $n );

               // Extract the description for this part

               if( eregi( "content-description: *([[:print:]]+)", $parthdr, $reg ) )
                  $partdesc = $reg[1];
               else if( eregi( "subject: *([[:print:]]+)", $parthdr, $reg ) )
                  $partdesc = $reg[1];
               else
                  $partdesc = "";

               // Check for quoted printable content

               if( eregi( "content-transfer-encoding: *quoted-printable", $parthdr ) )
                  $qp = true;
               else
                  $qp = false;

               if( strcasecmp( $parttype, "text/plain" ) && (strcasecmp( $parttype, "text/html" ) || !$prefs["html"]) )
               {
                  $pn = urlencode( $partname );
                  $x = $index[$num-1][number];
                  echo( "<a target=_new href=$PHP_SELF/$pn?sid=$sid&cmd=view&msg=$x&part=$n><span class=attachment>" );
                  echo( "$partname ($parttype)" );
                  if( $partdesc != "" )
                     echo( " - $partdesc" );
                  echo( "</span></a><br>\n" );
               }

               // If the part is plain text, we display it.

               if( strcasecmp( $parttype, "text/plain" ) == 0 )
               {
                  echo( "<span class=plainbody>" );
                  if( stristr( $parthdr, "base64" ) )
                     $line = ExtractBASE64( $boundary[0], 0 );
                  else if( $qp )
                     $line = ExtractQP( $boundary[0], true, 0 );
                  else
                     $line = ExtractTEXT( $boundary[0], true );
                  echo( "</span>" );
               }

               // Render HTML parts if the user wants us to.

               else if( $prefs["html"] && strcasecmp( $parttype, "text/html" ) == 0 )
               {
                  echo( "<span class=htmlbody>" );
                  if( $qp )
                     $line = ExtractQP( $boundary[0], false, 0 );
                  else
                     $line = ExtractTEXT( $boundary[0], false );
                  echo( "</span><p>" );
               }

               // Display image files in-line if the user wants us to.

               else if( $prefs["images"] && eregi( "image/(bmp|gif|jpg|jpeg|pjpeg|x-xbitmap)", $parttype, $reg ) )
               {
                  $tmpfile = uniqid( "", true ) . "." . $reg[1];

                  $out = fopen( "phpost_temp/$tmpfile", "w" );

                  if( stristr( $parthdr, "base64" ) )
                     $line = ExtractBASE64( $boundary[0], $out );
                  else if( stristr( $parthdr, "uuencode" ) )
                     $line = ExtractUU( $boundary[0], $out );
                  else if( $qp )
                     $line = ExtractQP( $boundary[0], false, $out );

                  fclose( $out );

                  echo( "<img src=\"phpost_temp/$tmpfile\"><p>" );
               }

               // Otherwise we simply skip the data

               else
                  $line = FindBoundary( $boundary[0] );

               while( $line == $b2 )
               {
                  array_shift( $boundary );
                  $b2 = $boundary[0] . "--";
                  FindBoundary( $boundary[0] );
               }
            } 
         //}
         echo( "</td></tr></table>\n" );
      }
   }
?>
